---
name: Suggestion
about: Suggest an idea for this project
title: "[SUGGESTION] "
labels: suggestion
assignees: ''

---

**DISCLAIMERS TO SET EXPECTATIONS:** I'm generally against language feature requests/changes unless they can be shown to improve simplicity, safety, or toolability in a quantifiable way. So:
- _Please limit suggestions to quantifiable improvements to C++ simplicity, safety, or toolability._ Quantifiable means that there is some kind of measurable data that helps motivate the change and measure success. Two of the big ones that will get my attention are eliminating vulnerabilities and eliminating guidance, so use those below please.
- _Please do not suggest syntax changes._ I accept there are hundreds of opinions and everyone will prefer something a little different. Syntax isn't the big thing, fixing semantics is -- reducing concept count, increasing toolability, are the big payoff.
- _Please do not suggest things that amount to personal taste._ I accept there are hundreds of personal tastes and everyone will prefer something a little different. For example, established stakes in the ground include that this declaration syntax is going to be left-to-right, and it's going to use `:` for every declaration and only for declarations.

**Will your feature suggestion eliminate X% of security vulnerabilities of a given kind in current C++ code?** If yes, please be specific about the classes of bugs that would go away, with an example or two (especially a link to a real CVE or two).

**Will your feature suggestion _automate or eliminate_ X% of current C++ guidance literature?** If yes, please be specific about what current good guidance this helps make the default, and/or what guidelines we would no longer need to teach/learn or that would be simplified and how, with an example or two (especially a link to a real "Effective C++" or "C++ Core Guidelines" guideline or two). For ideas, you can refer to [my CppCon 2020 talk starting at 10:31](https://youtu.be/6lurOCdaj0Y?t=631) where I summarize a categorized breakdown based on over 600 C++ guidance literature rules I cataloged and analyzed.

**Describe alternatives you've considered.**
There's nearly always more than one way to improve something. What other options did you consider? Why is the one you're suggesting better than those?
